



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>（数据挖掘-入门-6）十折交叉验证和K近邻</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">（数据挖掘-入门-6）十折交叉验证和K近邻</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 16:24:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>主要内容：</p>
<p>1、十折交叉验证</p>
<p>2、混淆矩阵</p>
<p>3、K近邻</p>
<p>4、python实现</p>
<h2>一、十折交叉验证</h2>
<p>前面提到了数据集分为训练集和测试集，训练集用来训练模型，而测试集用来测试模型的好坏，那么单一的测试是否就能很好的衡量一个模型的性能呢？</p>
<p>答案自然是否定的，单一的测试集具有偶然性和随机性。因此本文介绍一种衡量模型（比如分类器）性能的方法&mdash;&mdash;十折交叉验证(10-fold cross validation)</p>
<p>什么是十折交叉验证？</p>
<p>假设有个数据集，需要建立一个分类器，如何验证分类器的性能呢？</p>
<p>将数据集随机均为为10份，依次选择某1份作为测试集，其他9份作为训练集，训练出来的模型对测试集进行分类，并统计分类结果，就这样，重复10次实验，综合所有分类结果，就可以得到比较稳定的评价结果（当然，由于是随机划分数据集，因此每次运行结果都不一致）。</p>
<p>附：当然也可以选择k折交叉验证，最极端的就是留1交叉验证，每次只留一个样本做测试集，但这样的计算规模太大。</p>
<h2>二、混淆矩阵</h2>
<p>混淆矩阵：confuse matrix</p>
<p>假设有n个类别，那么分类结果的统计可以通过一个n*n的矩阵来表示，即混淆矩阵。</p>
<p>对角线即为分类正确的样本数。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/585228/201510/585228-20151005163100331-336802715.jpg" /></p>
<h2>三、K近邻（KNN）</h2>
<p>在协同过滤中已经提到过K近邻，就是选择离某个样本最近的K个样本，根据该K个样本来决定此样本的数值或类别。</p>
<p>如果是连续数值，那么K近邻可以作为回归方法，通过K个样本的矩阵权重来拟合数值；</p>
<p>如果是离散数值，那么K近邻可以作为分类方法，通过K个样本的多数投票策略来决定类别；</p>
<h2>四、python实现</h2>
<p>数据集：</p>
<p><a href="https://raw.githubusercontent.com/zacharski/pg2dm-python/master/data/ch6/mpgData.zip" rel="external nofollow noreferrer">mpgData.zip</a></p>
<p><a href="https://raw.githubusercontent.com/zacharski/pg2dm-python/master/data/ch6/pimaSmall.zip" rel="external nofollow noreferrer">pimaSmall.zip</a></p>
<p><a href="https://raw.githubusercontent.com/zacharski/pg2dm-python/master/data/ch6/pima.zip" rel="external nofollow noreferrer">pima.zip</a></p>
<p>代码：</p>
<p>1、切分数据</p>
<div>
<div>
<pre class="prettyprint linenums"># divide data into 10 buckets<br />
import random

def buckets(filename, bucketName, separator, classColumn):<br />
    """the original data is in the file named filename<br />
    bucketName is the prefix for all the bucket names<br />
    separator is the character that divides the columns<br />
    (for ex., a tab or comma and classColumn is the column<br />
    that indicates the class"""

    # put the data in 10 buckets<br />
    numberOfBuckets = 10<br />
    data = {}<br />
    # first read in the data and divide by category<br />
    with open(filename) as f:<br />
        lines = f.readlines()<br />
    for line in lines:<br />
        if separator != '\t':<br />
            line = line.replace(separator, '\t')<br />
        # first get the category<br />
        category = line.split()[classColumn]<br />
        data.setdefault(category, [])<br />
        data[category].append(line)<br />
    # initialize the buckets<br />
    buckets = []<br />
    for i in range(numberOfBuckets):<br />
        buckets.append([])<br />
    # now for each category put the data into the buckets<br />
    for k in data.keys():<br />
        #randomize order of instances for each class<br />
        random.shuffle(data[k])<br />
        bNum = 0<br />
        # divide into buckets<br />
        for item in data[k]:<br />
            buckets[bNum].append(item)<br />
            bNum = (bNum + 1) % numberOfBuckets

    # write to file<br />
    for bNum in range(numberOfBuckets):<br />
        f = open("%s-%02i" % (bucketName, bNum + 1), 'w')<br />
        for item in buckets[bNum]:<br />
            f.write(item)<br />
        f.close()

# example of how to use this code<br />
buckets("pimaSmall.txt", 'pimaSmall',',',8)</pre>
</div>
</div>
<p>2、十折交叉验证</p>
<div>
<div>
<pre class="prettyprint linenums">#<br />
#<br />
#  Nearest Neighbor Classifier for mpg dataset<br />
#

class Classifier:<br />
    def __init__(self, bucketPrefix, testBucketNumber, dataFormat):

        """ a classifier will be built from files with the bucketPrefix<br />
        excluding the file with textBucketNumber. dataFormat is a string that<br />
        describes how to interpret each line of the data files. For example,<br />
        for the mpg data the format is:

        "class    num    num    num    num    num    comment"<br />
        """

        self.medianAndDeviation = []

        # reading the data in from the file

        self.format = dataFormat.strip().split('\t')<br />
        self.data = []<br />
        # for each of the buckets numbered 1 through 10:<br />
        for i in range(1, 11):<br />
            # if it is not the bucket we should ignore, read in the data<br />
            if i != testBucketNumber:<br />
                filename = "%s-%02i" % (bucketPrefix, i)<br />
                f = open(filename)<br />
                lines = f.readlines()<br />
                f.close()<br />
                for line in lines[1:]:<br />
                    fields = line.strip().split('\t')<br />
                    ignore = []<br />
                    vector = []<br />
                    for i in range(len(fields)):<br />
                        if self.format[i] == 'num':<br />
                            vector.append(float(fields[i]))<br />
                        elif self.format[i] == 'comment':<br />
                            ignore.append(fields[i])<br />
                        elif self.format[i] == 'class':<br />
                            classification = fields[i]<br />
                    self.data.append((classification, vector, ignore))<br />
        self.rawData = list(self.data)<br />
        # get length of instance vector<br />
        self.vlen = len(self.data[0][1])<br />
        # now normalize the data<br />
        for i in range(self.vlen):<br />
            self.normalizeColumn(i)

    ##################################################<br />
    ###<br />
    ###  CODE TO COMPUTE THE MODIFIED STANDARD SCORE

    def getMedian(self, alist):<br />
        """return median of alist"""<br />
        if alist == []:<br />
            return []<br />
        blist = sorted(alist)<br />
        length = len(alist)<br />
        if length % 2 == 1:<br />
            # length of list is odd so return middle element<br />
            return blist[int(((length + 1) / 2) -  1)]<br />
        else:<br />
            # length of list is even so compute midpoint<br />
            v1 = blist[int(length / 2)]<br />
            v2 =blist[(int(length / 2) - 1)]<br />
            return (v1 + v2) / 2.0

    def getAbsoluteStandardDeviation(self, alist, median):<br />
        """given alist and median return absolute standard deviation"""<br />
        sum = 0<br />
        for item in alist:<br />
            sum += abs(item - median)<br />
        return sum / len(alist)

    def normalizeColumn(self, columnNumber):<br />
       """given a column number, normalize that column in self.data"""<br />
       # first extract values to list<br />
       col = [v[1][columnNumber] for v in self.data]<br />
       median = self.getMedian(col)<br />
       asd = self.getAbsoluteStandardDeviation(col, median)<br />
       #print("Median: %f   ASD = %f" % (median, asd))<br />
       self.medianAndDeviation.append((median, asd))<br />
       for v in self.data:<br />
           v[1][columnNumber] = (v[1][columnNumber] - median) / asd

    def normalizeVector(self, v):<br />
        """We have stored the median and asd for each column.<br />
        We now use them to normalize vector v"""<br />
        vector = list(v)<br />
        for i in range(len(vector)):<br />
            (median, asd) = self.medianAndDeviation[i]<br />
            vector[i] = (vector[i] - median) / asd<br />
        return vector<br />
    ###<br />
    ### END NORMALIZATION<br />
    ##################################################

    def testBucket(self, bucketPrefix, bucketNumber):<br />
        """Evaluate the classifier with data from the file<br />
        bucketPrefix-bucketNumber"""

        filename = "%s-%02i" % (bucketPrefix, bucketNumber)<br />
        f = open(filename)<br />
        lines = f.readlines()<br />
        totals = {}<br />
        f.close()<br />
        for line in lines:<br />
            data = line.strip().split('\t')<br />
            vector = []<br />
            classInColumn = -1<br />
            for i in range(len(self.format)):<br />
                  if self.format[i] == 'num':<br />
                      vector.append(float(data[i]))<br />
                  elif self.format[i] == 'class':<br />
                      classInColumn = i<br />
            theRealClass = data[classInColumn]<br />
            classifiedAs = self.classify(vector)<br />
            totals.setdefault(theRealClass, {})<br />
            totals[theRealClass].setdefault(classifiedAs, 0)<br />
            totals[theRealClass][classifiedAs] += 1<br />
        return totals

    def manhattan(self, vector1, vector2):<br />
        """Computes the Manhattan distance."""<br />
        return sum(map(lambda v1, v2: abs(v1 - v2), vector1, vector2))

    def nearestNeighbor(self, itemVector):<br />
        """return nearest neighbor to itemVector"""<br />
        return min([ (self.manhattan(itemVector, item[1]), item)<br />
                     for item in self.data])

    def classify(self, itemVector):<br />
        """Return class we think item Vector is in"""<br />
        return(self.nearestNeighbor(self.normalizeVector(itemVector))[1][0])

def tenfold(bucketPrefix, dataFormat):<br />
    results = {}<br />
    for i in range(1, 11):<br />
        c = Classifier(bucketPrefix, i, dataFormat)<br />
        t = c.testBucket(bucketPrefix, i)<br />
        for (key, value) in t.items():<br />
            results.setdefault(key, {})<br />
            for (ckey, cvalue) in value.items():<br />
                results[key].setdefault(ckey, 0)<br />
                results[key][ckey] += cvalue

    # now print results<br />
    categories = list(results.keys())<br />
    categories.sort()<br />
    print(   "\n       Classified as: ")<br />
    header =    "        "<br />
    subheader = "      +"<br />
    for category in categories:<br />
        header += category + "   "<br />
        subheader += "----+"<br />
    print (header)<br />
    print (subheader)<br />
    total = 0.0<br />
    correct = 0.0<br />
    for category in categories:<br />
        row = category + "    |"<br />
        for c2 in categories:<br />
            if c2 in results[category]:<br />
                count = results[category][c2]<br />
            else:<br />
                count = 0<br />
            row += " %2i |" % count<br />
            total += count<br />
            if c2 == category:<br />
                correct += count<br />
        print(row)<br />
    print(subheader)<br />
    print("\n%5.3f percent correct" %((correct * 100) / total))<br />
    print("total of %i instances" % total)

tenfold("mpgData/mpgData/mpgData",        "class    num    num    num    num    num    comment")</pre>
</div>
</div>
<p>3、K近邻</p>
<div>
<div>
<pre class="prettyprint linenums">#<br />
#  K Nearest Neighbor Classifier for Pima dataset<br />
#

import heapq<br />
import random

class Classifier:<br />
    def __init__(self, bucketPrefix, testBucketNumber, dataFormat, k):

        """ a classifier will be built from files with the bucketPrefix<br />
        excluding the file with textBucketNumber. dataFormat is a string that<br />
        describes how to interpret each line of the data files. For example,<br />
        for the mpg data the format is:

        "class    num    num    num    num    num    comment"<br />
        """

        self.medianAndDeviation = []<br />
        self.k = k<br />
        # reading the data in from the file

        self.format = dataFormat.strip().split('\t')<br />
        self.data = []<br />
        # for each of the buckets numbered 1 through 10:<br />
        for i in range(1, 11):<br />
            # if it is not the bucket we should ignore, read in the data<br />
            if i != testBucketNumber:<br />
                filename = "%s-%02i" % (bucketPrefix, i)<br />
                f = open(filename)<br />
                lines = f.readlines()<br />
                f.close()<br />
                for line in lines[1:]:<br />
                    fields = line.strip().split('\t')<br />
                    ignore = []<br />
                    vector = []<br />
                    for i in range(len(fields)):<br />
                        if self.format[i] == 'num':<br />
                            vector.append(float(fields[i]))<br />
                        elif self.format[i] == 'comment':<br />
                            ignore.append(fields[i])<br />
                        elif self.format[i] == 'class':<br />
                            classification = fields[i]<br />
                    self.data.append((classification, vector, ignore))<br />
        self.rawData = list(self.data)<br />
        # get length of instance vector<br />
        self.vlen = len(self.data[0][1])<br />
        # now normalize the data<br />
        for i in range(self.vlen):<br />
            self.normalizeColumn(i)

    ##################################################<br />
    ###<br />
    ###  CODE TO COMPUTE THE MODIFIED STANDARD SCORE

    def getMedian(self, alist):<br />
        """return median of alist"""<br />
        if alist == []:<br />
            return []<br />
        blist = sorted(alist)<br />
        length = len(alist)<br />
        if length % 2 == 1:<br />
            # length of list is odd so return middle element<br />
            return blist[int(((length + 1) / 2) -  1)]<br />
        else:<br />
            # length of list is even so compute midpoint<br />
            v1 = blist[int(length / 2)]<br />
            v2 =blist[(int(length / 2) - 1)]<br />
            return (v1 + v2) / 2.0

    def getAbsoluteStandardDeviation(self, alist, median):<br />
        """given alist and median return absolute standard deviation"""<br />
        sum = 0<br />
        for item in alist:<br />
            sum += abs(item - median)<br />
        return sum / len(alist)

    def normalizeColumn(self, columnNumber):<br />
       """given a column number, normalize that column in self.data"""<br />
       # first extract values to list<br />
       col = [v[1][columnNumber] for v in self.data]<br />
       median = self.getMedian(col)<br />
       asd = self.getAbsoluteStandardDeviation(col, median)<br />
       #print("Median: %f   ASD = %f" % (median, asd))<br />
       self.medianAndDeviation.append((median, asd))<br />
       for v in self.data:<br />
           v[1][columnNumber] = (v[1][columnNumber] - median) / asd

    def normalizeVector(self, v):<br />
        """We have stored the median and asd for each column.<br />
        We now use them to normalize vector v"""<br />
        vector = list(v)<br />
        for i in range(len(vector)):<br />
            (median, asd) = self.medianAndDeviation[i]<br />
            vector[i] = (vector[i] - median) / asd<br />
        return vector<br />
    ###<br />
    ### END NORMALIZATION<br />
    ##################################################

    def testBucket(self, bucketPrefix, bucketNumber):<br />
        """Evaluate the classifier with data from the file<br />
        bucketPrefix-bucketNumber"""

        filename = "%s-%02i" % (bucketPrefix, bucketNumber)<br />
        f = open(filename)<br />
        lines = f.readlines()<br />
        totals = {}<br />
        f.close()<br />
        for line in lines:<br />
            data = line.strip().split('\t')<br />
            vector = []<br />
            classInColumn = -1<br />
            for i in range(len(self.format)):<br />
                  if self.format[i] == 'num':<br />
                      vector.append(float(data[i]))<br />
                  elif self.format[i] == 'class':<br />
                      classInColumn = i<br />
            theRealClass = data[classInColumn]<br />
            #print("REAL ", theRealClass)<br />
            classifiedAs = self.classify(vector)<br />
            totals.setdefault(theRealClass, {})<br />
            totals[theRealClass].setdefault(classifiedAs, 0)<br />
            totals[theRealClass][classifiedAs] += 1<br />
        return totals

    def manhattan(self, vector1, vector2):<br />
        """Computes the Manhattan distance."""<br />
        return sum(map(lambda v1, v2: abs(v1 - v2), vector1, vector2))

    def nearestNeighbor(self, itemVector):<br />
        """return nearest neighbor to itemVector"""<br />
        return min([ (self.manhattan(itemVector, item[1]), item)<br />
                     for item in self.data])

    def knn(self, itemVector):<br />
        """returns the predicted class of itemVector using k<br />
        Nearest Neighbors"""<br />
        # changed from min to heapq.nsmallest to get the<br />
        # k closest neighbors<br />
        neighbors = heapq.nsmallest(self.k,<br />
                                   [(self.manhattan(itemVector, item[1]), item)<br />
                     for item in self.data])<br />
        # each neighbor gets a vote<br />
        results = {}<br />
        for neighbor in neighbors:<br />
            theClass = neighbor[1][0]<br />
            results.setdefault(theClass, 0)<br />
            results[theClass] += 1<br />
        resultList = sorted([(i[1], i[0]) for i in results.items()], reverse=True)<br />
        #get all the classes that have the maximum votes<br />
        maxVotes = resultList[0][0]<br />
        possibleAnswers = [i[1] for i in resultList if i[0] == maxVotes]<br />
        # randomly select one of the classes that received the max votes<br />
        answer = random.choice(possibleAnswers)<br />
        return( answer)

    def classify(self, itemVector):<br />
        """Return class we think item Vector is in"""<br />
        # k represents how many nearest neighbors to use<br />
        return(self.knn(self.normalizeVector(itemVector)))                             

def tenfold(bucketPrefix, dataFormat, k):<br />
    results = {}<br />
    for i in range(1, 11):<br />
        c = Classifier(bucketPrefix, i, dataFormat, k)<br />
        t = c.testBucket(bucketPrefix, i)<br />
        for (key, value) in t.items():<br />
            results.setdefault(key, {})<br />
            for (ckey, cvalue) in value.items():<br />
                results[key].setdefault(ckey, 0)<br />
                results[key][ckey] += cvalue

    # now print results<br />
    categories = list(results.keys())<br />
    categories.sort()<br />
    print(   "\n       Classified as: ")<br />
    header =    "        "<br />
    subheader = "      +"<br />
    for category in categories:<br />
        header += "% 2s   " % category<br />
        subheader += "-----+"<br />
    print (header)<br />
    print (subheader)<br />
    total = 0.0<br />
    correct = 0.0<br />
    for category in categories:<br />
        row = " %s    |" % category<br />
        for c2 in categories:<br />
            if c2 in results[category]:<br />
                count = results[category][c2]<br />
            else:<br />
                count = 0<br />
            row += " %3i |" % count<br />
            total += count<br />
            if c2 == category:<br />
                correct += count<br />
        print(row)<br />
    print(subheader)<br />
    print("\n%5.3f percent correct" %((correct * 100) / total))<br />
    print("total of %i instances" % total)

print("SMALL DATA SET")<br />
tenfold("pimaSmall/pimaSmall/pimaSmall",<br />
        "num    num    num    num    num    num    num    num    class", 3)

print("\n\nLARGE DATA SET")<br />
tenfold("pima/pima/pima",<br />
        "num    num    num    num    num    num    num    num    class", 3)</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zdpgx9.html">Oracle 索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o755v9.html">Java核心 --- 枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vvpj9.html">ububtu 彻底卸载程序的几种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjkmwy8.html">OpenRisc-31-关于在设计具有DMA功能的ipcore时的虚实地址转换问题的分析与解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4vxdq.html">SQL中LEFT JOIN 和 inner join 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpromr9.html">LINUX下分区命令Parted详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ngm08.html">班级博客客户端Beta阶段发布说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2xz29.html">ProgressDialog的使用及逻辑处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj32vk9.html">eclipse更新time out的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gx1vzq.html">delphi 调用QQ邮箱发送邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4gorm9.html">关于datatables自适应以及自定义列宽度的总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyk04xq.html">数据文件resize扩容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4dn6e9.html">C&plus;&plus;获取本机IP地址信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0d0rq.html">EZ 2018 03 30 NOIP2018 模拟赛（六）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppjrwz9.html">PHP rabbitmq扩展安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppk2g49.html">20145213《网络对抗》逆向及Bof基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkzk2v8.html">django系列6--Ajax01 特点&comma; 基本格式&comma; 向前端发送数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvvlx39.html">浅谈Hibernate框架&lpar;一&rpar;&mdash;&mdash;&period;hbm&period;xml中的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd55lgv9.html">mysql 密码忘记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvvzw39.html">Linux LVM分区管理、扩展</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/963gdwy9.html">bzoj 4408&colon; &lbrack;Fjoi 2016&rsqb;神秘数 数学 可持久化线段树 主席树</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e32pe9.html">【BZOJ】2730&colon; &lbrack;HNOI2012&rsqb;矿场搭建【Tarjan找割点】【分联通块割点个数】</a>
			</li>
						<li><a href="https://www.batexi.com/a/963gzdv9.html">BZOJ 4726 POI 2017 Sabota&quest; 树形DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em26wx9.html">ZOJ3673&colon;1729</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql17d2k9.html">在win7下安装VC6&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko46erq.html">js比较两个String字符串找出不同，并将不同处高亮显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjlv0xq.html">Error &colon; The specified component was not reported by the VSS writer &lpar;Error 517&rpar; in Windows Server 2012 Backup</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlxmzr9.html">&amp;lt&semi;jsp&colon;directive&period;page import&equals;&amp;quot&semi;&amp;quot&semi;&sol;&amp;gt&semi;的用法和解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjlyjxq.html">比較两个 List 的值是否相等</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn0xl3q.html">转&colon; Go -- 单例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
